/**
 * @file          Campaign Planning Form
 * @author        Zan Sen (zansen.tai@3ds.com)
 */
import { ColorSOP, ColorSOPList } from '../../libappsop/colorsop';
import { FormSOP } from '../../libappsop/formsop';
import { GanttChartSOP } from '../../libappsop/ganttchartsop';

export class FormCampaignPlanning extends FormSOP {
  public gcCampaign = new GanttChartCampaignPlanning();

  public constructor() {
    super('FormCampaignPlanning');
  }
}

export class GanttChartCampaignPlanning extends GanttChartSOP {
  public static readonly title = 'Campaign Planning';
  public static readonly contextMenu = 'gcContextMenuCapacityPlanning';
  public readonly name = 'Campaign Planning';

  public constructor() {
    super('FormCampaignPlanning', 'GanttChartCapacityPlanning', GanttChartCampaignPlanning.contextMenu);
  }
}

const ganttChartCampaignPlanningContextMenuItem = {
  Delete: { ContextMenu: GanttChartCampaignPlanning.contextMenu, Name: 'MenuDelete', Label: 'Delete' },
  Create: { ContextMenu: GanttChartCampaignPlanning.contextMenu, Name: 'MenuCreate', Label: 'Create' },
};

export { ganttChartCampaignPlanningContextMenuItem as GanttChartCampaignPlanningContextMenuItem };

const ganttChartCampaignPlanningColors: ColorSOPList = {
  cyan: (): ColorSOP => ({ Rgb: 'rgba(153, 255, 255, 1)', Color: 'Cyan', Hex: '#99FFFF' }),
};

export { ganttChartCampaignPlanningColors as GanttChartCampaignPlanningColors };
